Xapian::DPHWeight Class Reference

This class implements the DPH weighting scheme. More...

Inheritance diagram for Xapian::DPHWeight:
[legend]

## Public Member Functions

| DPHWeight ()
| Construct a DPHWeight.
std::string | name () const
| Return the name of this weighting scheme. More...
std::string | serialise () const
| Return this object's parameters serialised as a single string. More...
DPHWeight * | unserialise (const std::string &serialised) const
| Unserialise parameters. More...
double | get_sumpart (Xapian::termcount wdf, Xapian::termcount doclen, Xapian::termcount uniqterms) const
| Calculate the weight contribution for this object's term to a document. More...
double | get_maxpart () const
| Return an upper bound on what get_sumpart() can return for any document. More...
double | get_sumextra (Xapian::termcount doclen, Xapian::termcount uniqterms) const
| Calculate the term-independent weight component for a document. More...
double | get_maxextra () const
| Return an upper bound on what get_sumextra() can return for any document. More...
Public Member Functions inherited from Xapian::Weight
| Weight ()
| Default constructor, needed by subclass constructors.
virtual | ~Weight ()
| Virtual destructor, because we have virtual methods.

## Additional Inherited Members

Public Types inherited from Xapian::Weight
enum | type_smoothing { TWO_STAGE_SMOOTHING = 1 , DIRICHLET_SMOOTHING = 2 , ABSOLUTE_DISCOUNT_SMOOTHING = 3 , JELINEK_MERCER_SMOOTHING = 4 , DIRICHLET_PLUS_SMOOTHING = 5 }
| Type of smoothing to use with the Language Model Weighting scheme. More...
Protected Types inherited from Xapian::Weight
enum | stat_flags { COLLECTION_SIZE = 1 , RSET_SIZE = 2 , AVERAGE_LENGTH = 4 , TERMFREQ = 8 , RELTERMFREQ = 16 , QUERY_LENGTH = 32 , WQF = 64 , WDF = 128 , DOC_LENGTH = 256 , DOC_LENGTH_MIN = 512 , DOC_LENGTH_MAX = 1024 , WDF_MAX = 2048 , COLLECTION_FREQ = 4096 , UNIQUE_TERMS = 8192 , TOTAL_LENGTH = COLLECTION_SIZE | AVERAGE_LENGTH }
| Stats which the weighting scheme can use (see need_stat()). More...
Protected Member Functions inherited from Xapian::Weight
void | need_stat (stat_flags flag)
| Tell Xapian that your subclass will want a particular statistic. More...
| Weight (const Weight &)
| Don't allow copying. More...
Xapian::doccount | get_collection_size () const
| The number of documents in the collection.
Xapian::doccount | get_rset_size () const
| The number of documents marked as relevant.
Xapian::doclength | get_average_length () const
| The average length of a document in the collection.
Xapian::doccount | get_termfreq () const
| The number of documents which this term indexes.
Xapian::doccount | get_reltermfreq () const
| The number of relevant documents which this term indexes.
Xapian::termcount | get_collection_freq () const
| The collection frequency of the term.
Xapian::termcount | get_query_length () const
| The length of the query.
Xapian::termcount | get_wqf () const
| The within-query-frequency of this term.
Xapian::termcount | get_doclength_upper_bound () const
| An upper bound on the maximum length of any document in the database. More...
Xapian::termcount | get_doclength_lower_bound () const
| A lower bound on the minimum length of any document in the database. More...
Xapian::termcount | get_wdf_upper_bound () const
| An upper bound on the wdf of this term. More...
Xapian::totallength | get_total_length () const
| Total length of all documents in the collection.

## Detailed Description

This class implements the DPH weighting scheme.

DPH is a representative scheme of the Divergence from Randomness Framework by Gianni Amati.

This is a parameter free weighting scheme and it should be used with query expansion to obtain better results. It uses the HyperGeometric Probabilistic model and Popper's normalization to calculate the risk gain.

For more information about the DFR Framework and the DPH scheme, please refer to : a.) Gianni Amati and Cornelis Joost Van Rijsbergen Probabilistic models of information retrieval based on measuring the divergence from randomness ACM Transactions on Information Systems (TOIS) 20, (4), 2002, pp. 357-389. b.) FUB, IASI-CNR and University of Tor Vergata at TREC 2007 Blog Track. G. Amati and E. Ambrosi and M. Bianchi and C. Gaibisso and G. Gambosi. Proceedings of the 16th Text Retrieval Conference (TREC-2007), 2008.

## Member Function Documentation

## get_maxextra()

double Xapian::DPHWeight::get_maxextra | ( |  | ) | const

virtual

Return an upper bound on what get_sumextra() can return for any document.

This information is used by the matcher to perform various optimisations, so strive to make the bound as tight as possible.

Implements Xapian::Weight.

## get_maxpart()

double Xapian::DPHWeight::get_maxpart | ( |  | ) | const

virtual

Return an upper bound on what get_sumpart() can return for any document.

This information is used by the matcher to perform various optimisations, so strive to make the bound as tight as possible.

Implements Xapian::Weight.

## get_sumextra()

double Xapian::DPHWeight::get_sumextra | ( | Xapian::termcount | doclen,
|  | Xapian::termcount | uniqterms
| ) |  | const

virtual

Calculate the term-independent weight component for a document.

The parameter gives information about the document which may be used in the calculations:

Parameters

  doclen | The document's length (unnormalised).
  uniqterms | The number of unique terms in the document.

Implements Xapian::Weight.

## get_sumpart()

double Xapian::DPHWeight::get_sumpart | ( | Xapian::termcount | wdf,
|  | Xapian::termcount | doclen,
|  | Xapian::termcount | uniqterms
| ) |  | const

virtual

Calculate the weight contribution for this object's term to a document.

The parameters give information about the document which may be used in the calculations:

Parameters

  wdf | The within document frequency of the term in the document.
  doclen | The document's length (unnormalised).
  uniqterms | Number of unique terms in the document (used for absolute smoothing).

Implements Xapian::Weight.

## name()

std::string Xapian::DPHWeight::name | ( |  | ) | const

virtual

Return the name of this weighting scheme.

This name is used by the remote backend. It is passed along with the serialised parameters to the remote server so that it knows which class to create.

Return the full namespace-qualified name of your class here - if your class is called FooWeight, return "FooWeight" from this method (Xapian::BM25Weight returns "Xapian::BM25Weight" here).

If you don't want to support the remote backend, you can use the default implementation which simply returns an empty string.

Reimplemented from Xapian::Weight.

## serialise()

std::string Xapian::DPHWeight::serialise | ( |  | ) | const

virtual

Return this object's parameters serialised as a single string.

If you don't want to support the remote backend, you can use the default implementation which simply throws Xapian::UnimplementedError.

Reimplemented from Xapian::Weight.

## unserialise()

DPHWeight* Xapian::DPHWeight::unserialise | ( | const std::string & | serialised | ) | const

virtual

Unserialise parameters.

This method unserialises parameters serialised by the serialise() method and allocates and returns a new object initialised with them.

If you don't want to support the remote backend, you can use the default implementation which simply throws Xapian::UnimplementedError.

Note that the returned object will be deallocated by Xapian after use with "delete". If you want to handle the deletion in a special way (for example when wrapping the Xapian API for use from another language) then you can define a static `operator delete` method in your subclass as shown here: https://trac.xapian.org/ticket/554#comment:1

Parameters

  serialised | A string containing the serialised parameters.

Reimplemented from Xapian::Weight.

The documentation for this class was generated from the following file:

- xapian/weight.h